{
BIRA\POZA\loza.txt
BOZA\roza.txt
BOZA\POZA\doza.txt
BOZA\koza.dat
BOZA\POZA\loza.txt
KOZA\loza.txt
BIRA\roza.txt
BIRA\POZA\doza.txt
KOZA\doza.txt


                              
                            --------------------

       :     
    .        -
               .
          ,     
  .             
         .   -
 ,           
     ,      -
 .     (input.txt),      
   ,  1   .        
 (output.txt)    . , ,   -
   ,    (   )  
     .     ,    
       .

 : ,         3  -
 :
   (1)     ,      
      .      
     (      )  
   .   (  )     -
        ,  . 
   -   ,     (Node)
         .
   (2)    ,       (1) -
    ,        -
  .   (   ID)      
    ,       . -
              -
 ,    -.
   (3)     ,       -
            -
 .         -
   .         -
     (   ID)     -
  .         -
   ,         -  
      .
           ,    -
      .    (1)   -
  ,      .   -
     ,        , -
    ()    ,    
   .     ,    -. 
    -  -       -
     TSortedCollection,   Borland Pascal 7.0.-
   -       -  
        Turbo Vision, 
   Borland Pascal.        Objects
 ,             
           ,    -
     ,      - -
   .        , 
     TSortedCollection     
      ,   .    -
            -
     - logN , N     -
 .            -
          N.logN,   N 
     .      :  -
       Tree.    
           . -
       (  ,   
    ,        -
  ).          
       .    -
               
 ,     ,  .
   (2)       ,  
     M.logM      M  ( 
  M   -  N).    ID     
    :
    - ID  ,          .
    - ID  ,     ,     
  ID-        (child nodes),  
         '#'     -
  .       ,    -
    ID-    (..   ),    -
    ID-.      ID-  
              
   ,   ID-      .
     ID-   ID       
     .    ,    -
    ,          
    (     ). 
 ID-          -  IDs 
            ID.(
 IDsPtr).     ID-       
       (3)   .
      -     
      .      
 :
   -    ,   ,  ,   -
   
   -      ,    ,   -
   .      ,      ID,
  ,      .   ID-
      ,     
              
        ,      
 ID   ID      -    ID- 
  .          , 
   -   ID- .         
            ,..
  A = B      B = A.       -
    (3).
   -            -
 ,          : -
      ,     -
  .           -
    .      Enabled  
          true  false. -
         (  ID-),   -
   ,      .    -
    .
    ,       . 
   ,          -
  ,   ,       
    .        ,  -
       Turbo Pascal 7.0 fow Windows.  
   (    ,    - 600KB   ,
        1MB).     
       DOS   Windows.      
    MB,   20-30  ,     
   1MB          1 min.  -
     1000-2000    50-100 KB   . 
        ,       -
    -    ,    ,
      ..   case sensetive.
           ,   -
         .


                                                
                                            --------------------------------
                                                                
                                                          .  
                                                          tel. (062) 3-14-36
                                                   e-mail: nakov@hotmail.com
}

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}
USES Objects, Strings;

CONST InFileName  = 'files.pas';
      OutFileName = '';

TYPE PString = ^string;
     PNode = ^TNode;
     NodeType = (aDir,aFile);
     PNodeList = ^TNodeList;
     PDirIDElement = ^TDirIDElement;
     TDirIDElement = record
                       ID: PChar;
                       Node: PNode;
                     end;
     TNode = record
               case aType: NodeType of
                 aDir:
                  (DirName: PString;
                   Nodes: PNodeList;
                   IDsPtr: PDirIDElement;
                   Parent: PNode;
		   Enabled: boolean);
                 aFile:
                  (FileName: PString);
               end;
     TNodeList = object(TSortedCollection)
                   function Compare(Key1,Key2:Pointer): integer; virtual;
                 end;
     TDirIDList = object(TSortedCollection)
                    function Compare(Key1,Key2:Pointer): integer; virtual;
                  end;
     TIDList = object(TSortedCollection)
                 function Compare(Key1,Key2:Pointer): integer; virtual;
               end;

Function TNodeList.Compare(Key1,Key2:Pointer): integer;
Var S1,S2: PString; {Compare Key1^.FileName^ and Key2^.FileName^ as strings}
Begin
  S1:= PNode(Key1)^.FileName;
  S2:= PNode(Key2)^.FileName;
  if S1^ > S2^ then Compare:= 1
  else if S1^ < S2^ then Compare:= -1
  else Compare:= 0;
End;

Function TIDList.Compare(Key1,Key2:Pointer): integer;
Begin {Compare Key1 and Key2 as PChars}
  Compare:= StrComp(Key1,Key2);
End;

Function TDirIDList.Compare(Key1,Key2:Pointer): integer;
Begin {Compare Key1^.ID and Key2^.ID as PChars}
  Compare:=StrComp(PDirIDElement(Key1)^.ID,PDirIDElement(Key2)^.ID);
End;


VAR Tree: TNode; {The tree of directories and files}
    IDs: TDirIDList; {Sorted list of ID-s of every node of the tree}


Procedure ReadTree; { Read the input file and put its content in the tree }
Var F: Text;
    Directory,S: string;

  Function AddNewNode(aParent:PNode;const Name:string;Tip:NodeType): PNode;
  Var NewNode: PNode; {Add a new child node in aParent's list and return it}
  Begin
    New(NewNode);
    with NewNode^ do
      begin
        GetMem(FileName,length(Name)+1); FileName^:=Name;
        aType:=Tip;
        Parent:=aParent;
        Enabled:=true;
        if Tip = aDir then
          New(Nodes,Init(0,1));
      end;
    aParent^.Nodes^.Insert(NewNode);
    AddNewNode:=NewNode;
  End;

  Function FindOrAddNode(Parent:PNode;const Key:string): PNode;
  Var T: TNode; {Return the chlid node of Parent with DirName "Key"}
      I: integer; {If such node does not exist, it is created}
  Begin
    T.FileName:=@Key;
    if Parent^.Nodes^.Search(@T,I) then
      FindOrAddNode:=Parent^.Nodes^.At(I)
    else FindOrAddNode:=AddNewNode(Parent,Key,aDir);
  End;

  Procedure InsertToTree(T:PNode);  {Insert given in "S" path and filename}
  Var Poz: byte; {in the tree. When path does not exist in tree, create it}
  Begin
    Poz:=Pos('\',S);
    if Poz = 0 then {S is a file. Insert it as child of T}
      AddNewNode(T,S+#0,aFile)
    else {S is a directory. If exist, search it, else create node for it}
       begin
         Directory:=copy(S,1,Poz-1); Delete(S,1,Poz);
         InsertToTree(FindOrAddNode(T,Directory));
       end;
  End;

Begin
  FillChar(Tree,SizeOf(Tree),0);
  Tree.Enabled:=true; New(Tree.Nodes,Init(0,16));
  Assign(F,InFileName); Reset(F); ReadLn(F);
  while not SeekEof(F) do
    begin {Add each line from input file to its location in the tree}
      ReadLn(F,S);
      InsertToTree(@Tree);
      if S = '' then Break;
    end;
  Close(F);
End;


Procedure CalculateTreeIDs; { Calculate the ID of each directory node }

  Function CalculateID(T:PNode): PChar; {Calculate ID of node T^ as pchar}
  Var IDList: TIDList; {obtained from ID-s of all children of T^ in}
      S: string[6];    {alphabetical order and the count of T^'s childs}
      RezLen,I: word;
      NewID: PDirIDElement;
  Begin
    with T^ do
      if aType = aFile then {ID of a file is the file name}
        CalculateID:= ptr(seg(FileName^),ofs(FileName^)+1)
      else
        begin {aType = aDir. Calculating T^.ID...}
          IDList.Init(1,1); IDList.Duplicates:=true;
          for I:= 0 to Nodes^.Count-1 do
            IDList.Insert( CalculateID(Nodes^.At(I)) );
          Str(Nodes^.Count,S); S:='#'+S; RezLen:=length(S);
          for I:= 0 to IDList.Count-1 do
            Inc(RezLen,StrLen(IDList.At(I)));
          New(NewID); {Allocate memory for the new element in IDs list}
          with NewID^ do
            begin {ID := #Children_count + ID_of_child1 + ID_of_child2 + ...}
	      Node:=T;
              GetMem(ID,RezLen+1); ID^:=#0; StrPCopy(ID,S);
              for I:= 0 to IDList.Count-1 do
                StrCat(ID,IDList.At(I));
              IDList.DeleteAll; IDList.Done;
              IDs.Insert(NewID);
              T^.IDsPtr:=NewID;
              CalculateID:=ID;
            end;
        end;
  End;

Var I: integer;
Begin
  IDs.Init(1,16); IDs.Duplicates:=true;
  with Tree do
    for I:= 0 to Nodes^.Count-1 do
      CalculateID(Nodes^.At(I));
End;


Procedure PrintEqualSubtrees;
{ Print to output file all equal trees without their equal subtrees }
Var F: Text;

  Function FullPath(T:PNode): string; {Return the full path to directory T}
  Var S: string;
  Begin
    S:='';
    while T <> @Tree do
      begin S:= T^.DirName^+'\'+S; T:= T^.Parent; end;
    FullPath:=S;
  End;

  Procedure EnableDiseableSubtree(T:PNode;State:boolean);
  Var I: integer; {Change to "State" .Enabled field of subtree T}
  Begin
    with T^ do
      if aType = aDir then
        begin
          T^.Enabled:=State;
          for I:= 0 to Nodes^.Count-1 do
            EnableDiseableSubtree(Nodes^.At(I),State);
        end;
  End;

  Procedure PrintEqualsAndDiseableSubtrees(T:PNode); {Print all enabled and}
  Var Poz: integer; {equal to T trees and make diseabled all nodes that can}
      Item,Item2: PDirIDElement; {be reached from any equal to T node}
  Begin
    Item:=T^.IDsPtr;
    with IDs do
      begin
        Poz:=IndexOf(Item);
        for Poz:= Poz-1 downto 0 do
          begin {Find all directories in IDs list equal to T}
            Item2:= At(Poz);
            if Compare(Item,Item2) <> 0 then
              Break {The next directory in list is not equal to current}
            else if Item2^.Node^.Enabled then
              begin {Only enabled equal nodes are processed}
                WriteLn(F,FullPath(Item^.Node),' = ',FullPath(Item2^.Node));
                EnableDiseableSubtree(Item2^.Node,false);
              end;
          end;
      end;
  End;

  Procedure EnableSubtrees(T:PNode); {Enables all nodes that can be reached}
  Var Poz: integer; {from any equal to T node and are diseabled at current}
      Item,Item2: PDirIDElement; {step of recursion of "Explore" procedure}
  Begin
    Item:=T^.IDsPtr;
    with IDs do
      begin
        Poz:=IndexOf(Item);
        for Poz:= Poz-1 downto 0 do
          begin {Find all directories in IDs list equal to T}
            Item2:= At(Poz);
            if Compare(Item,Item2) <> 0 then
              Break {The next directory in list is not equal to current}
            else if Item2^.Node^.Parent^.Enabled then
              EnableDiseableSubtree(Item2^.Node,true);
          end;
      end;
  End;

  Procedure Explore(T:PNode); {Explore the tree and print its equal dirs}
  Var I: integer;
  Begin
    with T^ do
      if aType = aDir then {only directories are explored}
        begin {visit T and all its child subtrees}
          PrintEqualsAndDiseableSubtrees(T);
          for I:= 0 to Nodes^.Count-1 do
            Explore(Nodes^.At(I));
          EnableSubtrees(T);
        end;
  End;

Var I: integer;
Begin
  Assign(F,OutFileName); Rewrite(F);
  with Tree do
    for I:= 0 to Nodes^.Count-1 do
      Explore(Nodes^.At(I));
  WriteLn(F);
  Close(F);
End;

BEGIN
  ReadTree;           {1}
  CalculateTreeIDs;   {2}
  PrintEqualSubtrees; {3}
END.
