{  :  N;   1 e1 e2 ...;   2 e1 e2 ...;   N e1 e2 ...;
4
1 2 4
2 3 4
3 4
4


 --------------------------------------------------------------------------
           ,    
      " " - ,    -
     . ,  INFOMAN      -
       ,    -  ,
             (TRO.PAS).
 ---------------------------------------------------------------------------


   G    ,    
   ,       . .  
   i  k,   k  j        i  j.

  -   ,  :

   i-j     i  j,
       i->j    i  j,
       i#j     / i  j.

  :
  1)  i->j, j-k, i#k,      j->k.
  2)  i->j, i-k, j#k,      i->k.

     :
   R1:  i->j, j-k, i#k,    j-k,  k->j.
   R2:  i->j, i-k, j#k,    i-k,  i->k.

 
 ---------
 1.        .
 2.      R1  R2,   :

        i->j.      
   i  j,      
   :

    1).    j-k.
     a)  i#k   j-k  ,     j<-k.
     )  i#k   j-k    j->k     ..
         .

    2).    i-k.
     a)  j#k   i-k  ,     i->k.
     )  j#k   i-k    i<-k     ..
         .

 3.      .      
       . .
             
        2.

}

{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P+,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520,0,655360}

const Max = 100;

const
  rNotDir = 1;  {   }
  rDir    = 2;  {   }
  rNone   = 0;  {   }

type
  TGraph = array[1..Max,1..Max] of byte;
  TRib = record
           a,b: integer;
           Dir: byte;
         end;

  TRibArray = array[1..Max*Max] of TRib;

Var
  G: TGraph;
  N: integer;

procedure ReadGraph(const S:string);
Var
 br,i,j: integer;
 F: Text;
begin
  FillChar(G, SizeOf(G),0);

  assign(F,S); reset(F); readln(F);

  readln(F,N);

  for br:= 1 to N do
    begin
      read(F,i);

      while not seekEoln(F) do
       begin
         read(f,j);
         G[i,j]:= rNotDir;
         G[j,i]:= rNotDir;
       end;

     readln(F);
    end;

  close(F);
end;

procedure WriteGraph(Var G:TGraph);
Var
 i,j: integer;
begin
  WriteLn;
  for i:=1 to N do
    begin
      WriteLn;
        for j:=1 to N do
          write(byte(G[i,j]):2);
    end;
  WriteLn;
end;

procedure TrOrient;
Var
  RQue: TRibArray;
  RCount,Deleted: word;
  i,j,who,a,b,k: word;
  qB, qE: word;
  Flag,Ok: boolean;
  MyR: TRib;

  NewG: TGraph;

 Label
  ExitAll;
begin
  FillChar(NewG, SizeOf(NewG), rNone);

  Ok:=false;

  repeat
    Flag:=false;

    for i:=1 to N-1 do
      begin
       for j:=i+1 to N do
        if G[i,j] = rNotDir then
          begin
            Flag:=true;
            A:=i;
            B:=j;

            G[i,j]:=rDir;
            G[j,i]:=rNone;

            break;
          end;

       if Flag then break;
      end;

    if not Flag then
      begin
        Ok:=true;
        break;
      end;

    qB:=1; qE:=1;  MyR.a:=a;  MyR.b:=b;  MyR.Dir:=rDir; RQue[qB]:=MyR;

    while qB <= qE do
      begin
        MyR:=RQue[qB];

        for k:=1 to N do
          if (k <> MyR.A) and (k <> MyR.B) then
          begin
            if (G[MyR.B ,K] <> rNone) and (G[MyR.A, K] = rNone)
               and (G[K, MyR.A] = rNone) then
                if G[MyR.B, K] = rNotDir then
                   begin
                     G[K, MyR.B]:= rDir;
                     G[MyR.B, k]:= rNone;
                     inc(qE);
                     RQue[qE].A:=K;
                     RQue[qE].B:=MyR.B;
                     RQue[qE].Dir:=rDir;
                   end
                     else Goto ExitAll;

            if (G[K, MyR.A] <> rNone) and (G[MyR.B, K] = rNone)
               and (G[K, MyR.B] = rNone) then
               if G[K, MyR.A] = rNotDir then
                  begin
                     G[MyR.A, K]:= rDir;
                     G[K, MyR.A]:= rNone;
                     inc(qE);
                     RQue[qE].A:=MyR.A;
                     RQue[qE].B:=K;
                     RQue[qE].Dir:=rDir
                  end
                    else Goto ExitAll;
          end;

        inc(qB);
      end;


    for i:=1 to qE do
       begin
         G[ RQue[i].A , RQue[i].B ]:=rNone;
         G[ RQue[i].B , RQue[i].A ]:=rNone;

         NewG[ RQue[i].A, RQue[i].B ] := rDir;
       end;
  until false;

  ExitAll:

  if Ok then
    begin
      WriteLn('   .     :');
      WriteLn;
      WriteGraph(NewG);
    end
  else
    WriteLN('    ');
end;

begin
  ReadGraph('TRO.PAS');
  WriteGraph(G);

  TrOrient;
end.